# -*- coding: utf-8 -*-

# 获取客户端引擎API模块
import mod.client.extraClientApi as clientApi
# 获取客户端system的基类ClientSystem
ClientSystem = clientApi.GetClientSystemCls()

# 在modMain中注册的Client System类
class AnimRemixClientSystem(ClientSystem):

    # 客户端System的初始化函数
    def __init__(self, namespace, systemName):
        # 首先初始化TutorialClientSystem的基类ClientSystem
        super(AnimRemixClientSystem, self).__init__(namespace, systemName)
        print "==== AnimRemixClientSystem Init ===="

        #将本地玩家id传送给服务端
        self.playerID = clientApi.GetLocalPlayerId()
        self.count_use_time = 0
        self.count_use_time_1 = 0
        self.model_id = []
        self.playerPos = None
        self.playerRot = None
        self.direction = None
        self.ListenEvent()

    def ListenEvent(self):
        self.ListenForEvent(clientApi.GetEngineNamespace(), clientApi.GetEngineSystemName(), "ClientItemTryUseEvent", self, self.ItemUseOnEvent)

    def UnListenEvent(self):
        self.UnListenEvent(clientApi.GetEngineNamespace(), clientApi.GetEngineSystemName(), "ClientItemTryUseEvent", self, self.ItemUseOnEvent)

    def ItemUseOnEvent(self, data):
        comp = clientApi.GetEngineCompFactory().CreateModel(self.playerID)
        if data["itemDict"]["newItemName"] == "minecraft:arrow":
            if self.count_use_time == 0:
                #计数器自增
                self.count_use_time  += 1
                # 获取玩家位置、方位、direction
                self.playerPos = clientApi.GetEngineCompFactory().CreatePos(self.playerID).GetPos()
                self.playerRot = clientApi.GetEngineCompFactory().CreateRot(self.playerID).GetRot()
                self.direction = clientApi.GetDirFromRot(self.playerRot)
                #建两个模型并将其设在玩家前方
                left_model_id = comp.CreateFreeModel("netease_appear_steve")
                self.model_id.append(left_model_id)
                middle_model_id = comp.CreateFreeModel("netease_appear_steve")
                self.model_id.append(middle_model_id)
                right_model_id = comp.CreateFreeModel("netease_appear_steve")
                self.model_id.append(right_model_id)

                comp.SetFreeModelPos(self.model_id[-1], self.playerPos[0]-1.5, self.playerPos[1]+self.direction[0], self.playerPos[2]+self.direction[1]*2)
                comp.SetFreeModelPos(self.model_id[-2], self.playerPos[0], self.playerPos[1]+self.direction[0], self.playerPos[2]+self.direction[1]*2)
                comp.SetFreeModelPos(self.model_id[-3], self.playerPos[0]+1.5, self.playerPos[1]+self.direction[0], self.playerPos[2]+self.direction[1]*2)
            elif self.count_use_time  == 1:
                #计数器自增
                self.count_use_time  += 1
                comp.ModelPlayAni(self.model_id[-1], 'run', True, False, 1)
                comp.ModelPlayAni(self.model_id[-2], 'run', True, False, 1)
                comp.ModelPlayAni(self.model_id[-3], 'attack', True, False, 1)
            elif self.count_use_time  == 2:
                #计数器自增
                self.count_use_time  += 1
                comp.SetAnimationBoneMask(self.model_id[-2], 'run', ["up"], False, True)
            elif self.count_use_time  == 3:
                #计数器自增
                self.count_use_time  += 1
                comp.ModelPlayAni(self.model_id[-2], 'attack', True, 1, 0)
            elif self.count_use_time  == 4:
                #计数器自增
                self.count_use_time  += 1
                for ani in comp.GetPlayingAnimList(self.model_id[-2]):
                    comp.CancelAllBoneMask(self.model_id[-2], ani)
                for i in range(-3,0):
                    for ani in comp.GetPlayingAnimList(self.model_id[i]):
                        comp.ModelStopAni(self.model_id[i], ani)
            elif self.count_use_time  == 5:
                self.count_use_time  += 1
                comp.ModelPlayAni(self.model_id[-1], 'run', True, False, 1)
                comp.ModelPlayAni(self.model_id[-3], 'die', True, False, 1)
            elif self.count_use_time  == 6:
                #计数器自增
                self.count_use_time  += 1
                comp.ModelPlayAni(self.model_id[-2], 'run', True, False, 1)
                comp.ModelPlayAni(self.model_id[-2], 'die', True, True, 1)
                comp.RegisterAnim1DControlParam(self.model_id[-2], "run", "die", "arm_control_param")
                comp.SetAnim1DControlParam(self.model_id[-2], "arm_control_param", 0.5)
            else:
                for  i in range(-3,0):
                    comp.RemoveFreeModel(self.model_id[i])
                self.count_use_time  = 0
        elif data["itemDict"]["newItemName"] == "minecraft:bamboo":
            if self.count_use_time_1 == 0:
                #计数器自增
                self.count_use_time_1  += 1
                # 获取玩家位置、方位、direction
                self.playerPos = clientApi.GetEngineCompFactory().CreatePos(self.playerID).GetPos()
                self.playerRot = clientApi.GetEngineCompFactory().CreateRot(self.playerID).GetRot()
                self.direction = clientApi.GetDirFromRot(self.playerRot)
                #建两个模型并将其设在玩家前方
                left_model_id = comp.CreateFreeModel("datiangou_A")
                self.model_id.append(left_model_id)
                middle_model_id = comp.CreateFreeModel("datiangou_B")
                self.model_id.append(middle_model_id)

                comp.SetFreeModelPos(self.model_id[-1], self.playerPos[0]-1.5, self.playerPos[1]+self.direction[0], self.playerPos[2]+self.direction[1]*2)
                comp.SetFreeModelPos(self.model_id[-2], self.playerPos[0], self.playerPos[1]+self.direction[0], self.playerPos[2]+self.direction[1]*2)
            else:
                for  i in range(-2,0):
                    comp.RemoveFreeModel(self.model_id[i])
                self.count_use_time_1 = 0
    # 函数名为Destroy才会被调用，在这个System被引擎回收的时候会调这个函数来销毁一些内容
	def Destroy(self):
		self.UnListenEvent()