# -*- coding: utf-8 -*-

# 获取引擎服务端API的模块
import mod.server.extraServerApi as serverApi
# 获取引擎服务端System的基类，System都要继承于ServerSystem来调用相关函数
ServerSystem = serverApi.GetServerSystemCls()

class AnimRemixServerSystem(ServerSystem):

    # ServerSystem的初始化函数
    def __init__(self, namespace, systemName):
        # 首先调用父类的初始化函数
        super(AnimRemixServerSystem, self).__init__(namespace, systemName)
        print "===== AnimRemixServerSystem init ====="
        # 初始时调用监听函数监听事件
        self.playerID = None
        self.ListenEvent()
		
    def ListenEvent(self):
        self.ListenForEvent(serverApi.GetEngineNamespace(), serverApi.GetEngineSystemName(), "ClientLoadAddonsFinishServerEvent", self, self.OnClientLoadAddonsFinishServerEvent)

    # 客户端加载完mod时触发该回调函数
    def OnClientLoadAddonsFinishServerEvent(self, args):
        # 将玩家id设置为全局变量
        self.playerID = args["playerId"]
        print "玩家id==============",args

        #装备物品
        itemDict = {
            'itemName': 'minecraft:arrow',
            'count': 64,
            'auxValue': 0,
        }
        comp = serverApi.GetEngineCompFactory().CreateItem(self.playerID)
        comp.SpawnItemToPlayerInv(itemDict, self.playerID, 0)

        itemDict = {
            'itemName': 'minecraft:bamboo',
            'count': 64,
            'auxValue': 0,
        }
        comp.SpawnItemToPlayerInv(itemDict, self.playerID, 1)

    
	def Destroy(self):
		self.UnListenForEvent("AnimRemixMod","AnimRemixClientSystem","GetPlayerID",self,self.GetPlayerID)