# -*- coding: utf-8 -*-

# 这行是import到MOD的绑定类Mod，用于绑定类和函数
from mod.common.mod import Mod
# 这行import到的是引擎服务端的API模块
import mod.server.extraServerApi as serverApi
# 这行import到的是引擎客户端的API模块
import mod.client.extraClientApi as clientApi

@Mod.Binding(name = "AnimRemixMod", version = "0.0.1")
class AnimRemixMod(object):

    def __init__(self):
        print "===== init AnimRemix Mod ====="

    # InitServer绑定的函数作为服务端脚本初始化的入口函数，通常是用来注册服务端系统system和组件component
    @Mod.InitServer()
    def AnimRemixServerInit(self):
        print "===== init AnimRemix server ====="
        # 函数可以将System注册到服务端引擎中，实例的创建和销毁交给引擎处理。第一个参数是MOD名称，第二个是System名称，第三个是自定义MOD System类的路径
        # 取名名称尽量个性化，不能与其他人的MOD冲突，可以使用英文、拼音、下划线这三种。
        serverApi.RegisterSystem("AnimRemixMod", "AnimRemixServerSystem", "AnimRemixScirpt.AnimRemixServerSystem.AnimRemixServerSystem")

    # DestroyServer绑定的函数作为服务端脚本退出的时候执行的析构函数，通常用来反注册一些内容,可为空
    @Mod.DestroyServer()
    def AnimRemixServerDestroy(self):
        print "===== destroy AnimRemix server ====="

    # InitClient绑定的函数作为客户端脚本初始化的入口函数，通常用来注册客户端系统system和组件component
    @Mod.InitClient()
    def AnimRemixClientInit(self):
        print "===== init AnimRemixMod client ====="
        # 函数可以将System注册到客户端引擎中，实例的创建和销毁交给引擎处理。第一个参数是MOD名称，第二个是System名称，第三个是自定义MOD System类的路径
        # 取名名称尽量个性化，不能与其他人的MOD冲突，可以使用英文、拼音、下划线这三种。
        clientApi.RegisterSystem("AnimRemixMod", "AnimRemixClientSystem", "AnimRemixScirpt.AnimRemixClientSystem.AnimRemixClientSystem")

    # DestroyServer绑定的函数作为服务端脚本退出的时候执行的析构函数，通常用来反注册一些内容,可为空
    @Mod.DestroyServer()
    def AnimRemixClientDestroy(self):
        print "===== destroy AnimRemix client ====="